# hhelper

[![pipeline status](https://git.tpage.io/tyler/hhelper/badges/master/pipeline.svg)](https://git.tpage.io/tyler/hhelper/commits/master)

homelab helper script for use in my other projects

### Requirements

* `hvac` - Hashicorp Vault API Client

* `slixmpp` - Async XMPP client

### Currently supported helper functions:

* `vault_test(address, entity, token)` - Tests a given vault server to ensure it is initialized, unsealed, and that the token provided is valid. Returns `False` if one of those criterion is not true

* `get_vault_secret(secret, cache=True)` - Retrieves a secret from vault using the local cache file if available. The secret format should be `secret/foo`, and the function returns `False` if vault is not ready or the secret cannot be retrieved

* `send_xmpp(room, message, file=None)` - Sends an XMPP message to a specified room with an optional file attachment

* `send_log_message(room, level, message)` - A wrapper for `send_xmpp` that prefixes the message from a list of log levels for easier readability

* `log(message, level, log_file)` - Functionally the same to `send_log_message()` but instead of sending the message via XMPP, it logs it to a file on disk